diff -NaurdbB -xCVS -xconfigure$ -xconfig.h.in -xMakefile.in mrbayes-3.1.2.old/mcmc.c mrbayes-3.1.2.new/mcmc.c
--- mrbayes-3.1.2.old/mcmc.c	Wed Apr 18 12:19:46 EDT 2007
+++ mrbayes-3.1.2.new/mcmc.c	Thu Nov 22 12:52:14 EST 2007
@@ -6184,11 +6437,11 @@
 |		variation using fast log approximation
 |
 -----------------------------------------------------------------*/
-int CondLikeScaler_NUC4_fast (TreeNode *p, int division, int chain)
+int CondLikeScaler_NUC4_fast (TreeNode *p, int division, int chain, int do_full_scaling)
 
 {
-	int				c, i, j, k, x, *expPtr, log_2;
-	CLFlt			scaler, *scPNew, *scPOld, *lnScaler, *clP;
+	int				c, i, j, k, x, *expPtr, log_2, doing_full_scaling;
+	CLFlt			scaler, *clP, *scPNew, *scPOld, *lnScaler;
 	ModelInfo		*m;
 	
 	m = &modelSettings[division];
@@ -6209,8 +6462,22 @@
 		FlipOneBit(division,&p->scalersSet[0]);	/* clear flag marking scalers set */
 		}
 
-	/* multiply by new values only if currently a scaler node */
+#if defined(ALTSCALING)
+	if ((p->left == NULL) || (! do_full_scaling))
+	  doing_full_scaling = 0;
+	else {
+	  doing_full_scaling = 1;
+	  did_scaling = 1;
+	}
+#else
 	if (p->scalerNode == YES)
+	  doing_full_scaling = 1;
+	else
+	  doing_full_scaling = 0;
+#endif
+
+	/* multiply by new values only if currently a scaler node */
+	if (doing_full_scaling)
 		{
 		i = j = 0;
 		for (c=0; c<m->numChars; c++)
@@ -6281,11 +6548,11 @@
 |	CondLikeScaler_NY98: codon model with omega variation
 |
 -----------------------------------------------------------------*/
-int CondLikeScaler_NY98 (TreeNode *p, int division, int chain)
+int CondLikeScaler_NY98 (TreeNode *p, int division, int chain, int do_full_scaling)
 
 {
 
-	int				c, i, j, k, n, nStates;
+	int				c, i, j, k, n, nStates, doing_full_scaling;
 	CLFlt			scaler, *clP, *scPNew, *scPOld, *lnScaler;
 	ModelInfo		*m;
 
@@ -6308,8 +6575,22 @@
 		FlipOneBit(division,&p->scalersSet[0]);
 		}
 
-	/* add new values only if currently a scaler node */
+#if defined(ALTSCALING)
+	if ((p->left == NULL) || (! do_full_scaling))
+	  doing_full_scaling = 0;
+	else {
+	  doing_full_scaling = 1;
+	  did_scaling = 1;
+	}
+#else
 	if (p->scalerNode == YES)
+	  doing_full_scaling = 1;
+	else
+	  doing_full_scaling = 0;
+#endif
+
+	/* add new values only if currently a scaler node */
+	if (doing_full_scaling)
 		{
 		i = j = 0;
 		for (c=0; c<m->numChars; c++)
@@ -6350,11 +6631,11 @@
 |		rate variation
 |
 -----------------------------------------------------------------*/
-int CondLikeScaler_Std (TreeNode *p, int division, int chain)
+int CondLikeScaler_Std (TreeNode *p, int division, int chain, int do_full_scaling)
 
 {
 
-	int				a, c, i, j, k, nStates, numReps;
+	int				a, c, i, j, k, nStates, numReps, doing_full_scaling;
 	CLFlt			scaler, *clP, *scPNew, *scPOld, *lnScaler;
 	ModelInfo		*m;
 	
@@ -6376,8 +6657,22 @@
 		FlipOneBit (division, &p->scalersSet[0]);
 		}
 
-	/* add new values only if currently a scaler node */
+#if defined(ALTSCALING)
+	if ((p->left == NULL) || (! do_full_scaling))
+	  doing_full_scaling = 0;
+	else {
+	  doing_full_scaling = 1;
+	  did_scaling = 1;
+	}
+#else
 	if (p->scalerNode == YES)
+	  doing_full_scaling = 1;
+	else
+	  doing_full_scaling = 0;
+#endif
+
+	/* add new values only if currently a scaler node */
+	if (doing_full_scaling)
 		{
 		i = j = 0;
 		for (c=0; c<m->numChars; c++)
@@ -7603,7 +7898,7 @@
 			else if (expecting == Expecting(NUMBER))
 				{
 				sscanf (tkn, "%d", &tempI);
-				runIDSeed = tempI;
+				runIDSeed = tempI; /* should the below be runIDSeed, not swapSeed? XXX - Allen */
 				MrBayesPrint ("%s   Setting run ID [stamp] seed to %ld [for GRID use]\n", spacer, swapSeed);
 				expecting = Expecting(PARAMETER) | Expecting(SEMICOLON);
 				}
@@ -7957,6 +8252,12 @@
 					free(tempStr);
 					return (ERROR);
 					}
+				if ((chainParams.useAdapt == YES) && (tempI > 1)) {
+				  MrBayesPrint ("%s   Too many runs (maximum of 1 run with Adapt)\n",
+						spacer);
+				  free(tempStr);
+				  return (ERROR);
+				}
 				chainParams.numRuns = tempI;
 				fileNameChanged = YES;
 				MrBayesPrint ("%s   Setting number of runs to %d\n", spacer, chainParams.numRuns);
@@ -7988,6 +8289,18 @@
 					free(tempStr);
 					return (ERROR);
 					}
+				if ((chainParams.useSA == YES) && (tempI > 1)) {
+				  MrBayesPrint ("%s   Too many chains (maximum of 1 chain with Simulated Annealing)\n",
+						spacer);
+				  free(tempStr);
+				  return (ERROR);
+				}
+				if ((chainParams.useAdapt == YES) && (tempI > 1)) {
+				  MrBayesPrint ("%s   Too many chains (maximum of 1 chain with Adapt)\n",
+						spacer);
+				  free(tempStr);
+				  return (ERROR);
+				}
 				chainParams.numChains = tempI;
 				MrBayesPrint ("%s   Setting number of chains to %d\n", spacer, chainParams.numChains);
 				expecting = Expecting(PARAMETER) | Expecting(SEMICOLON);
@@ -7999,9 +8312,18 @@
 				}
 			}
 		/* set Temp (chainTemp) ***************************************************************/
-		else if (!strcmp(parmName, "Temp"))
-			{
-			if (expecting == Expecting(EQUALSIGN))
+		else if (!strcmp(parmName, "Temp")) {
+		  if (chainParams.useSA == YES) {
+		    MrBayesPrint ("%s   Chain temps are incompatible with current Simulated Annealing implementation\n",
+				  spacer);
+		    free(tempStr);
+		    return (ERROR);
+		  } else if (chainParams.useAdapt == YES) {
+		    MrBayesPrint ("%s   Chain temps are incompatible with current Adapt implementation\n",
+				  spacer);
+		    free(tempStr);
+		    return (ERROR);
+		  } else if (expecting == Expecting(EQUALSIGN))
 				{
 				tempIndex = 0;
 				expecting = Expecting(NUMBER) | Expecting(LEFTPAR);
@@ -8047,9 +8369,80 @@
 				free(tempStr);
 				return (ERROR);
 				}
+		/* set SimAnneal (useSA) - Allen */
+		} else if (!strcmp(parmName, "SimAnneal")) {
+		  if (expecting == Expecting(EQUALSIGN))
+		    expecting = Expecting(ALPHA);
+		  else if (expecting == Expecting(ALPHA)) {
+		    if (IsArgValid(tkn, tempStr) == NO_ERROR) {
+		      if (!strcmp(tempStr, "Yes")) {
+			if (chainParams.numChains == 4) { /* default */
+			  MrBayesPrint ("%s   Setting chains to 1 due to SimAnneal\n", spacer);
+			  chainParams.numChains = 1;
+			} else if (chainParams.numChains > 1) {
+			  MrBayesPrint ("%s   %d chains invalid for SimAnneal\n", spacer, chainParams.numChains);
+			  free (tempStr);
+			  return (ERROR);
+			}
+			chainParams.useSA = YES;
+		      } else
+			chainParams.useSA = NO;
+		    } else {
+		      MrBayesPrint ("%s   Invalid argument for SimAnneal\n", spacer);
+		      free (tempStr);
+		      return (ERROR);
+		    }
+		    if (chainParams.useSA == YES)
+		      MrBayesPrint ("%s   Using (single-chain) Simulated Annealing\n", spacer);
+		    else
+		      MrBayesPrint ("%s   Not using (single-chain) Simulated Annealing\n", spacer);
+		    expecting = Expecting(PARAMETER) | Expecting(SEMICOLON);
+		  } else {
+		    free(tempStr);
+		    return (ERROR);
+		  }
+		/* set Adapt (useAdapt) - Allen */
+		} else if (!strcmp(parmName, "Adapt")) {
+		  if (expecting == Expecting(EQUALSIGN))
+		    expecting = Expecting(ALPHA);
+		  else if (expecting == Expecting(ALPHA)) {
+		    if (IsArgValid(tkn, tempStr) == NO_ERROR) {
+		      if (!strcmp(tempStr, "Yes")) {
+			if (chainParams.numChains == 4) { /* default */
+			  MrBayesPrint ("%s   Setting chains to 1 due to Adapt\n", spacer);
+			  chainParams.numChains = 1;
+			} else if (chainParams.numChains > 1) {
+			  MrBayesPrint ("%s   %d chains invalid for Adapt\n", spacer, chainParams.numChains);
+			  free (tempStr);
+			  return (ERROR);
+			}
+			if (chainParams.numRuns == 2) { /* default */
+			  MrBayesPrint ("%s   Setting runs to 1 due to Adapt\n", spacer);
+			  chainParams.numRuns = 1;
+			} else if (chainParams.numRuns > 1) {
+			  MrBayesPrint ("%s   %d runs invalid for Adapt\n", spacer, chainParams.numRuns);
+			  free (tempStr);
+			  return (ERROR);
+			}
+			chainParams.useAdapt = YES;
+		      } else
+			chainParams.useAdapt = NO;
+		    } else {
+		      MrBayesPrint ("%s   Invalid argument for Adapt\n", spacer);
+		      free (tempStr);
+		      return (ERROR);
+		    }
+		    if (chainParams.useAdapt == YES)
+		      MrBayesPrint ("%s   Using (single-chain) Adaptation\n", spacer);
+		    else
+		      MrBayesPrint ("%s   Not using (single-chain) Adaptation\n", spacer);
+		    expecting = Expecting(PARAMETER) | Expecting(SEMICOLON);
+		  } else {
+		    free(tempStr);
+		    return (ERROR);
 			}
 		/* set Reweight (weightScheme) ********************************************************/
-		else if (!strcmp(parmName, "Reweight"))
+		} else if (!strcmp(parmName, "Reweight"))
 			{
 			if (expecting == Expecting(EQUALSIGN))
 				expecting = Expecting(LEFTPAR);
@@ -8218,14 +8611,19 @@
 					free(tempStr);
 					return (ERROR);
 					}
-				if (tempD > 0.50)
-					{
-					MrBayesPrint ("%s   Burnin fraction too high (> 0.50)\n", spacer);
+				if (tempD > 0.90)
+				  { /* changed from 0.50 - Allen */
+					MrBayesPrint ("%s   Burnin fraction too high (> 0.90)\n", spacer);
 					free(tempStr);
 					return (ERROR);
 					}
 				chainParams.burninFraction = tempD;
-				MrBayesPrint ("%s   Setting burnin fraction to %.2f\n", spacer, chainParams.burninFraction);
+				if (((tempD > 0.50) && (chainParams.useSA != YES)) || (tempD > 0.75))
+				  MrBayesPrint ("%s   Setting burnin fraction to %.3f (this is high!)\n", spacer,
+						chainParams.burninFraction);
+				else
+				  MrBayesPrint ("%s   Setting burnin fraction to %.3f\n", spacer,
+						chainParams.burninFraction);
 				expecting = Expecting(PARAMETER) | Expecting(SEMICOLON);
 				}
 			else 
@@ -8287,7 +8685,7 @@
 					return (ERROR);
 					}
 				chainParams.stopVal = tempD;
-				MrBayesPrint ("%s   Setting burnin fraction to %.2f\n", spacer, chainParams.burninFraction);
+				MrBayesPrint ("%s   Setting stopval to %.6f\n", spacer, chainParams.stopVal);
 				expecting = Expecting(PARAMETER) | Expecting(SEMICOLON);
 				}
 			else 
@@ -8667,7 +9065,7 @@
 {
 
 	int			b, c, i, j, k, n, chn, index, nOfParams, tempInt;
-	MrBFlt		sum, *bs, *value, *subValue, symDir[10], scaler;
+	MrBFlt		sum, *bs, *value, *subValue, symDir[10], scaler, tempFlt;
 
 	Param		*p;
 	ModelInfo	*m;
@@ -8690,6 +9088,8 @@
 		MrBayesPrint ("%s   paramValues not free in FillNormalParams\n", spacer);
 		return ERROR;
 		}
+	MrBayesPrint("%s   Allocating paramValues for %d params\n", spacer,
+		     nOfParams); /* -Allen */
 	paramValues = (MrBFlt *) calloc (nOfParams, sizeof(MrBFlt));
 	if (!paramValues)
 		{
@@ -9008,16 +9408,12 @@
 
 					/* if user has not set dirichlet parameters, go with default */
 					/* overall variance equals number of states */
-					if (mp->numDirParams == 0)
-						for (i=0; i<mp->nStates; i++)
+					if (mp->numDirParams == 0) {
+						for (i=0; i<mp->nStates; i++) {
 							value[i] = mp->stateFreqsDir[i] = 1.0;
-					else
-						for (i=0; i<mp->nStates; i++)
-							value[i] = mp->stateFreqsDir[i];
-
 					/* now fill in subvalues */
-					for (i=0; i<mp->nStates; i++)
 						subValue[i] =  (1.0 / mp->nStates);
+						}
 #					if defined ASYMMETRY
 					if (mp->dataType == RESTRICTION)
 						{
@@ -9025,9 +9421,16 @@
 							subValue[i] =  0.5;
 						}
 #					endif
+					} else { /* Allen */
+						sum = 0.0;
+						for (i=0; i<mp->nStates; i++) {
+							value[i] = mp->stateFreqsDir[i];
+							sum += mp->stateFreqsDir[i];
 					}
-
-				else if (p->paramId == PI_USER)
+						for (i=0; i<mp->nStates; i++)
+							subValue[i] = mp->stateFreqsDir[i]/sum;
+					}
+				} else if (p->paramId == PI_USER)
 					{
 					for (i=0; i<mp->nStates; i++)
 						subValue[i] =  mp->stateFreqsFix[i];
@@ -9090,8 +9493,10 @@
 					{
 					if (GetEmpiricalFreqs (p->relParts, p->nRelParts) == ERROR)
 						return (ERROR);
-					for (i=0; i<mp->nStates; i++)
+					  for (i=0; i<mp->nStates; i++) {
 						value[i] = empiricalFreqs[i];
+						subValue[i] = empiricalFreqs[i]; /* Allen */
+					  }
 					}
 
 				else if (p->paramId == PI_EQUAL)
@@ -9154,12 +9559,14 @@
 				/* first get hyperprior */
 				if (p->paramId == SHAPE_UNI)
 					{
-					value[0] = 0.5;
-					if (value[0] < mp->shapeUni[0] || value[0] > mp->shapeUni[1])
-						value[0] = mp->shapeUni[0] + (mp->shapeUni[1] - mp->shapeUni[0]) *  0.5;
+					  value[0] = 0.65; /* Grishin distance - Allen */
+					  if (value[0] < mp->shapeUni[0])
+					    value[0] = mp->shapeUni[0] + (mp->shapeUni[1] - mp->shapeUni[0]) *  0.1;
+					  else if (value[0] > mp->shapeUni[1])
+					    value[0] = mp->shapeUni[0] + (mp->shapeUni[1] - mp->shapeUni[0]) *  0.9;
 					}
 				else if (p->paramId == SHAPE_EXP)
-					value[0] = 0.5;
+					value[0] = 0.65;
 				else if (p->paramId == SHAPE_FIX)
 					value[0] = mp->shapeFix;
 				/* now fill in rates */
@@ -9169,9 +9576,8 @@
 			else if (p->paramType == P_PINVAR)
 				{
 				/* Fill in pInvar ***************************************************************************************/
-				if (p->paramId == PINVAR_UNI)
-					value[0] = 0.0;
-
+				if (p->paramId == PINVAR_UNI) /* was 0.0 - Allen */
+				  value[0] = mp->pInvarUni[0] + (mp->pInvarUni[1] - mp->pInvarUni[0]) *  0.1;
 				else if (p->paramId == PINVAR_FIX)
 					value[0] =  mp->pInvarFix;
 				}
@@ -9178,21 +9584,23 @@
 			else if (p->paramType == P_CORREL)
 				{
 				/* Fill in correlation parameter of adgamma model *******************************************************/
-				if (p->paramId == CORREL_UNI)
+				  if (p->paramId == CORREL_UNI) { /* was just 0.0 - Allen */
 					value[0] = 0.0;
-
-				else if (p->paramId == CORREL_FIX)
+				    if (value[0] < mp->corrUni[0])
+				      value[0] = mp->corrUni[0];
+				    else if (value[0] > mp->corrUni[1])
+				      value[0] = mp->corrUni[1];
+				  } else if (p->paramId == CORREL_FIX)
 					value[0] =  mp->corrFix;
 				
 				/* Fill in correlation matrices */
 				AutodGamma (subValue, value[0], mp->numGammaCats);
 				}
-			else if (p->paramType == P_SWITCH)
-				{
+			else if (p->paramType == P_SWITCH) {
 				/* Fill in switchRates for covarion model ***************************************************************/
 				for (j=0; j<2; j++)
 					{
-					if (p->paramId == SWITCH_UNI)
+					if ((p->paramId == SWITCH_UNI) || (p->paramId == SWITCH_PINVUNI))
 						value[j] = RandomNumber(seed) * (mp->covswitchUni[1] - mp->covswitchUni[0]) + mp->covswitchUni[0];
 
 					else if (p->paramId == SWITCH_EXP)
@@ -9201,8 +9609,22 @@
 					else if (p->paramId == SWITCH_FIX)
 						value[j] = mp->covswitchFix[j];
 					}
+				if (p->paramId == SWITCH_PINVUNI) { /* - Allen */
+				  if ((value[0]+value[1]) < LIKE_EPSILON) {
+				    value[0] += 0.5*(mp->covswitchUni[1] - mp->covswitchUni[0]);
+				    value[1] += 0.5*(mp->covswitchUni[1] - mp->covswitchUni[0]);
 				}
-			else if (p->paramType == P_RATEMULT)
+				  tempFlt = value[1]/(value[0]+value[1]);
+				  if (tempFlt > mp->covswitchMaxPinvar) {
+				    value[1] = (mp->covswitchMaxPinvar*value[0])/(1-mp->covswitchMaxPinvar);
+				    if (value[1] < mp->covswitchUni[0]) {
+				      value[1] = mp->covswitchUni[0];
+				      value[0] =
+					(value[1]*(1-mp->covswitchMaxPinvar))/mp->covswitchMaxPinvar;
+				    }
+				  }
+				}
+			} else if (p->paramType == P_RATEMULT)
 				{
 				/* Fill in rateMult for division rates ******************************************************************/
 				for (j=0; j<p->nValues; j++)
@@ -9359,10 +9781,10 @@
 		goto errorExit;
 		}
 	memAllocs[ALLOC_NUMSITESOFPAT] = NO;
-	numSitesOfPat = (CLFlt *) realloc((void *) numSitesOfPat, numCompressedChars * chainParams.numChains * sizeof(MrBFlt));
+	numSitesOfPat = (CLFlt2 *) realloc((void *) numSitesOfPat, numCompressedChars * chainParams.numChains * sizeof(CLFlt2));
 	if (!numSitesOfPat)
 		{
-		MrBayesPrint ("%s   Problem reallocating numSitesOfPat (%d)\n", spacer, numCompressedChars * chainParams.numChains * sizeof(MrBFlt));
+		MrBayesPrint ("%s   Problem reallocating numSitesOfPat (%d)\n", spacer, numCompressedChars * chainParams.numChains * sizeof(CLFlt2));
 		goto errorExit;
 		}
 	memAllocs[ALLOC_NUMSITESOFPAT] = YES;
@@ -10563,7 +10985,7 @@
 	
 	int				c, i, n, division;
 	long			*pL, *pR, *pP, *pA, x;
-	CLFlt			*nSitesOfPat;
+	CLFlt2			*nSitesOfPat;
 	TreeNode        *p;
 	ModelInfo		*m;
 
@@ -10636,7 +11058,7 @@
 	
 	int				c, i, n, division;
 	long			*pL, *pR, *pP, x;
-	CLFlt			*nSitesOfPat; 
+	CLFlt2			*nSitesOfPat; 
 	TreeNode		*p;
 	ModelInfo		*m;
 
@@ -10685,7 +11107,7 @@
 	
 	int				c, i, n, division;
 	long			*pL, *pR, *pP, *pA, x;
-	CLFlt			*nSitesOfPat;
+	CLFlt2			*nSitesOfPat;
 	MrBFlt			length;
 	TreeNode		*p;
 	ModelInfo		*m;
@@ -11144,7 +11566,7 @@
 	int				i, j, c, d;
 	long			*cl, *clL, *clR, *clA, *clU, *clM, x, y, z;
 	CLFlt			temp1, temp2=0.0;
-	CLFlt			*nSitesOfPat;
+	CLFlt2			*nSitesOfPat;
 	TreeNode		*p, *q;
 	ModelInfo		*m;
 
@@ -11417,6 +11839,7 @@
 
 	/* For now, we wonly allow random swaps in the MPI version. Other schemes require
 	   tagging of messages, or a dedicated server node doing message processing.      */
+	/* ? that is the opposite of what the below code does... XXX - Allen */
 	(*swapA) = (int) (RandomNumber(&swapSeed) * chainParams.numChains);
 	(*swapB) = (int) (RandomNumber(&swapSeed) * (chainParams.numChains - 1));
 	if ((*swapB) == (*swapA))
@@ -11424,14 +11847,12 @@
 
 #	else
 
-	if (chainParams.swapAdjacentOnly == NO)
-		{
+	if (chainParams.swapAdjacentOnly == NO) {
 		(*swapA) = (int) (RandomNumber(&swapSeed) * chainParams.numChains);
 		(*swapB) = (int) (RandomNumber(&swapSeed) * (chainParams.numChains - 1));
 		if ((*swapB) == (*swapA))
 			(*swapB) = chainParams.numChains - 1;
-		}
-	else
+	} else
 		{
 		(*swapA) = (int) (RandomNumber(&swapSeed) * (chainParams.numChains - 1));
 		(*swapB) = (*swapA) + 1;
@@ -11523,7 +11944,8 @@
 
 	/* check if conditional likelihoods are needed */
 	if (oneMatSize > 0)
-		MrBayesPrint ("%s   Initializing conditional likelihoods for internal nodes\n", spacer);
+	  MrBayesPrint ("%s   Initializing conditional likelihoods for internal nodes (oneMatSize is %d)\n",
+			spacer, oneMatSize); /* - Allen */
 	else
 		return NO_ERROR;
 
@@ -11553,6 +11975,8 @@
 		MrBayesPrint ("%s   the conditional likelihoods for the chain. Please try\n", spacer);
 		MrBayesPrint ("%s   allocating more memory to the program, or running the\n", spacer);
 		MrBayesPrint ("%s   data on a computer with more memory.\n", spacer);
+		MrBayesPrint ("%s   numLocalChains: %d; oneMatSize: %d; nNodes: %d.\n",
+			      spacer,numLocalChains,oneMatSize,nNodes); /* Allen */
 		return ERROR;
 		}	
 	else
@@ -11578,6 +12002,8 @@
 		MrBayesPrint ("%s   the conditional likelihoods for the chain. Please try\n", spacer);
 		MrBayesPrint ("%s   allocating more memory to the program, or running the\n", spacer);
 		MrBayesPrint ("%s   data on a computer with more memory.\n", spacer);
+                MrBayesPrint ("%s   numLocalChains: %d; nScalerNodes: %d; numCompressedChars: %d.\n",
+			      spacer,numLocalChains,nScalerNodes,numCompressedChars); /* Allen */
 		if (treeScalerSpace) 
 			free (treeScalerSpace);
 		if (treeScaler) 
@@ -11803,15 +12229,15 @@
 		return ERROR;
 		}
 #if defined SSE
-	tiProbSpace = (CLFlt *) ALIGNEDMALLOC (2 * numLocalChains * nNodes * tiProbRowSize * sizeof(CLFlt), 16);
+	tiProbSpace = (CLFlt2 *) ALIGNEDMALLOC (2 * numLocalChains * nNodes * tiProbRowSize * sizeof(CLFlt2), 16);
 #else
-	tiProbSpace = (CLFlt *) SafeMalloc (2 * numLocalChains * nNodes * tiProbRowSize * sizeof(CLFlt));
+	tiProbSpace = (CLFlt2 *) SafeMalloc (2 * numLocalChains * nNodes * tiProbRowSize * sizeof(CLFlt2));
 	
 	/* PAUL: initialization of ti data, otherwise (according to valgrind) uninitialized data is used in some of
 	 * the likelihood functions. This might be a bug! */
-	/*memset(tiProbSpace, 0, 2 * numLocalChains * nNodes * tiProbRowSize * sizeof(CLFlt));*/
+	/*memset(tiProbSpace, 0, 2 * numLocalChains * nNodes * tiProbRowSize * sizeof(CLFlt2));*/
 #endif
-	tiProbs = (CLFlt **) SafeMalloc (numLocalChains * sizeof(CLFlt *));
+	tiProbs = (CLFlt2 **) SafeMalloc (numLocalChains * sizeof(CLFlt2 *));
 	if (!tiProbSpace || !tiProbs)
 		{
 		MrBayesPrint ("%s   The program ran out of memory while trying to allocate\n", spacer);
@@ -11886,7 +12312,10 @@
 			MrBayesPrint ("%s   The program ran out of memory while trying to allocate\n", spacer);
 			MrBayesPrint ("%s   the eigen values and vectors for the chain. Please try\n", spacer);
 			MrBayesPrint ("%s   allocating more memory to the program, or running the\n", spacer);
-			MrBayesPrint ("%s   data on a computer with more memory.\n", spacer);
+			MrBayesPrint ("%s   data on a computer with more memory. (2*%d*%d*%d=%d (%d/chain) bytes)\n",
+				      spacer, numLocalChains,cijkRowSize,sizeof(MrBFlt),
+				      2*numLocalChains*cijkRowSize*sizeof(MrBFlt),
+				      2*cijkRowSize*sizeof(MrBFlt));
 			if (cijkSpace) 
 				free (cijkSpace);
 			if (cijks) 
@@ -12651,9 +13080,10 @@
 
 {
 
-	int			c, d, i, j, k, s, maxRates, numReps, oneMatSize,
+  int			c, d, i, j, k, s, maxRates, numReps, oneMatSize, nObs,
 				corrModel[MAX_NUM_DIVS];
 	long int	*charBits;
+	MrBFlt          *bs, sum;
 	CLFlt		*cL;
 	ModelInfo	*m;
 	ModelParams *mp=NULL;
@@ -12690,7 +13120,7 @@
 
 	/* check if conditional likelihoods are needed */
 	if (oneMatSize > 0)
-		MrBayesPrint ("%s   Initializing conditional likelihoods for terminals\n", spacer);
+		MrBayesPrint ("%s   Initializing conditional likelihoods for terminals (oneMatSize is %d)\n", spacer, oneMatSize);
 	else
 		return NO_ERROR;
 
@@ -12833,7 +13263,7 @@
 
 	/* allocate and set space for terminal conditional likelihoods unless	*/
 	/* we are going to augment data											*/
-	for (d=0; d<numCurrentDivisions; d++)
+	for (d=0; d<numCurrentDivisions; d++) /* umm... mp = &modelParams[d] needed? - Allen */
 		if (!strcmp(mp->augmentData, "Yes"))
 			return NO_ERROR;
 
@@ -12854,7 +13284,9 @@
 		MrBayesPrint ("%s   The program ran out of memory while trying to allocate\n", spacer);
 		MrBayesPrint ("%s   the tip conditional likelihoods for the chain. Please try\n", spacer);
 		MrBayesPrint ("%s   allocating more memory to the program, or running the\n", spacer);
-		MrBayesPrint ("%s   data on a computer with more memory.\n", spacer);
+		MrBayesPrint ("%s   data on a computer with more memory (oneMatSize is %d).\n", spacer,
+			      oneMatSize);
+		/* - Allen */
 		return ERROR;
 		}	
 	
@@ -12863,8 +13295,7 @@
 		termCondLikes[i] = 0.0;
 
 	/* fill in conditional likelihoods */
-	for (d=0; d<numCurrentDivisions; d++)
-		{
+	for (d=0; d<numCurrentDivisions; d++) {
 		m = &modelSettings[d];
 		mp = &modelParams[d];
 		
@@ -12897,26 +13328,38 @@
 			/* TODO: fill in from compressed matrix */
 			
 			}
-		else
-			{
+		else { /* not doing this for standard - not sure as to proper statefreqs et al - Allen */
+		  bs = GetParamSubVals (m->stateFreq, 0, 0); /* as if chain 0 */
 			numReps = m->numModelStates / mp->nStates;
 			numReps *= m->numTiCats;
 
-			for (i=0; i<numLocalTaxa; i++)
-				{
+		  for (i=0; i<numLocalTaxa; i++) {
 				charBits = parsMatrix + m->parsMatrixStart + i * parsMatrixRowSize;
 				cL = termCondLikes + m->condLikeStart + i * condLikeRowSize;
-				for (c=m->compCharStart; c<m->compCharStop; c++)
-					{
-					for (k=0; k<numReps; k++)
-						{
-						for (s=0; s<mp->nStates; s++)
-							{
+		    for (c=m->compCharStart; c<m->compCharStop; c++) {
+		      for (k=0; k<numReps; k++) {
+			nObs = 0;
+			sum = 0.0;
+			for (s=0; s<mp->nStates; s++) {
+			  if (IsBitSet(s, charBits)) {
+			    nObs++;
+			    sum += bs[s];
+			  }
+			}
+			if ((nObs > 1) && (sum > LIKE_EPSILON)) {
+			  for (s=0; s<mp->nStates; s++) {
+			    if (IsBitSet(s, charBits))
+			      (*cL) = bs[s]/sum;
+			    cL++;
+			  }
+			} else {
+			  for (s=0; s<mp->nStates; s++) {
 							if (IsBitSet(s, charBits))
 								(*cL) = 1.0;
 							cL++;
 							}
 						}
+		      }
 					charBits += m->nParsIntsPerSite;
 					}
 				}
@@ -13452,10 +13894,11 @@
 int Likelihood_Gen (TreeNode *p, int division, int chain, MrBFlt *lnL, int whichSitePats)
 
 {
-	int				c, j, k, nStates, hasPInvar;
-	MrBFlt			s01, s10, probOn, probOff, *swr;
+	int				c, j, k, nStates, hasPInvar, toreturn = NO_ERROR;
+	MrBFlt			s01=50.0, s10=50.0, probOn, probOff, *swr;
 	MrBFlt			covBF[40], freq, *bs, *clInvar=NULL, like, likeI, pInvar=0.0, lnLike;
-	CLFlt			*clP, *lnScaler, *nSitesOfPat;
+	CLFlt			*clP, *lnScaler;
+	CLFlt2                  *nSitesOfPat;
 	ModelInfo		*m;
 	
 	/* find model settings and nStates, pInvar, invar cond likes */
@@ -13492,7 +13935,10 @@
 		for (j=0; j<nStates/2; j++)
 			{
 			covBF[j] = bs[j] * probOn;
-			covBF[j+nStates/2] = bs[j] * probOff;
+			/* try to reduce numerical inaccuracy - Allen */
+			covBF[j+(nStates/2)] = bs[j] - covBF[j];
+			if (covBF[j+(nStates/2)] < LIKE_EPSILON)
+			  covBF[j+(nStates/2)] = bs[j] * probOff;
 			}
 
 		/* finally set bs pointer to adjusted values */
@@ -13531,15 +13977,50 @@
 			like *= freq;
 
 			/* check against LIKE_EPSILON (values close to zero are problematic) */
-			if (like < LIKE_EPSILON)
-				{
-				MrBayesPrint ("%s   WARNING: In LIKE_EPSILON - for division %d char %d has like = %1.30lf\n", spacer, division, c, like);
+			if (like < LIKE_EPSILON) {
+#if defined(ALTSCALING)
+			  had_like_epsilon = 1;
+			  if (! did_scaling)
+			    return ERROR;
+#endif
+		          if (m->switchRates != NULL)
+			    MrBayesPrint("%s   WARNING: In LIKE_EPSILON - for division %d (partition %d) char %d has like = %1.30lf (s01 is %2.15lf, s10 is %2.15lf, lnScaler = %lf)\n",
+					 spacer, division, division+1, c, like, s01, s10, lnScaler[c]);
+			  else
+			    MrBayesPrint("%s   WARNING: In LIKE_EPSILON - for division %d (partition %d) char %d has like = %1.30lf (lnScaler = %lf)\n",
+					 spacer, division, division+1, c, like, lnScaler[c]);
+			  toreturn = ERROR;
+			  /* failing to add in would be saying that is very _likely_... - Allen */
+			  (*lnL) += (lnScaler[c] + log(LIKE_EPSILON)) * nSitesOfPat[c];
+			} else {
+			  lnLike = lnScaler[c] + log(like);
+
+#if defined(ALTSCALING)
+			  if ((! did_scaling) && (lnLike > LIKE_EPSILON)) {
+			    if (m->switchRates != NULL)
+			      MrBayesPrint("%s   WARNING: Likelihood_Gen - for division %d (partition %d) char %d has like %1.30lf lnLike %1.30lf (s01 %2.15lf, s10 %2.15lf, lnScaler %lf)\n",
+					   spacer, division, division+1, c, like, lnLike, s01, s10, lnScaler[c]);
+			    else
+			      MrBayesPrint("%s   WARNING: Likelihood_Gen - for division %d (partition %d) char %d has like %1.30lf lnLike %1.30lf (lnScaler %lf)\n",
+					   spacer, division, division+1, c, like, lnScaler[c]);
+			    had_like_epsilon = 1;
 				return ERROR;
 				}
+#endif
+
+#ifdef DEBUG_SCALER_NAN
+			  if (! (isfinite(lnLike))) {
+			    if (m->switchRates != NULL)
+			      MrBayesPrint("%s   WARNING: For division %d (partition %d) char %d has lnLike %1.30lf (like = %1.30lf, s01 is %2.15lf, s10 is %2.15lf, lnScaler = %lf)\n",
+					   spacer, division, division+1, c, lnLike, like, s01, s10, lnScaler[c]);
 			else	
-				{
-				(*lnL) += (lnScaler[c] +  log(like)) * nSitesOfPat[c];
+			      MrBayesPrint("%s   WARNING: For division %d (partition %d) char %d has lnLike %1.30lf (like = %1.30lf, lnScaler = %lf)\n",
+					   spacer, division, division+1, c, lnLike, like, lnScaler[c]);
+			    return ERROR;
 				}
+#endif
+			  (*lnL) += lnLike * nSitesOfPat[c];
+			}
 			}
 		}
 	else
@@ -13573,24 +14054,43 @@
 			else
 				lnLike = log (like + (likeI / exp (lnScaler[c]))) + lnScaler[c];
 
+#ifdef DEBUG_SCALER_NAN
+			  if (! (isfinite(lnLike))) {
+			    	MrBayesPrint("%s   WARNING: For division %d (partition %d) char %d has lnLike %1.30lf (like = %1.30lf, likeI = %1.30lf, lnScaler = %lf)\n",
+					   spacer, division, division+1, c, lnLike, like, likeI, lnScaler[c]);
+				return ERROR;
+			  }
+#endif
 			/* check against LIKE_EPSILON (values close to zero are problematic) */
-			if (like < LIKE_EPSILON)
-				{
+			  if (((lnScaler[c] >= -200) || (likeI <= 1E-70)) && (like < LIKE_EPSILON)) {
+			    /* see "forget about like" above for why additional conditions - Allen */
 #ifdef DEBUG_OUTPUT
 				printf ("lnScaler[%d] = %lf likeI = %lf\n", c, lnScaler[c], likeI);
 #endif
-				MrBayesPrint ("%s   WARNING: In LIKE_EPSILON - for division %d char %d has like = %1.30lf\n", spacer, division, c, like);
+#if defined(ALTSCALING)
+			    had_like_epsilon = 1;
+			    if (! did_scaling)
+			      return ERROR;
+#endif
+			    MrBayesPrint ("%s   WARNING: In LIKE_EPSILON - for division %d char %d has like = %1.30lf\n",
+					  spacer, division, c, like);
 				getchar();
+			    /* leaving "return ERROR" because am not seeing this and don't want
+			       to alter without being able to test - Allen */
 				return ERROR;
-				}
-			else	
-				{
+#if defined(ALTSCALING)
+			  } else if ((! did_scaling) && (lnLike > LIKE_EPSILON)) {
+			    MrBayesPrint ("%s   WARNING: Likelihood_Gen - for division %d char %d has like %1.30lf, likeI %1.30lf, lnScaler %lf, lnLike %1.30lf\n",
+					  spacer, like, likeI, lnScaler[c], lnLike);
+			    had_like_epsilon = 1;
+			    return ERROR;
+#endif
+			  } else
 				(*lnL) += lnLike * nSitesOfPat[c];
 				}
 			}		
-		}
 		
-	return NO_ERROR;
+	return toreturn; /* admittedly, return value is actually ignored in all cases... XXX - Allen */
 	
 }
 
@@ -13610,7 +14110,8 @@
 
 	int				c, i, k, hasPInvar;
 	MrBFlt			freq, likeI, *bs, like, *clInvar=NULL, pInvar=0.0, lnLike;
-	CLFlt			*clP, *lnScaler, *nSitesOfPat;
+	CLFlt			*clP, *lnScaler;
+	CLFlt2                  *nSitesOfPat;
 	ModelInfo		*m;
 	
 	/* find model settings and pInvar, invar cond likes */
@@ -13663,6 +14164,11 @@
 			/* check against LIKE_EPSILON (values close to zero are problematic) */
 			if (like < LIKE_EPSILON)
 				{
+#if defined(ALTSCALING)
+				had_like_epsilon = 1;
+				if (! did_scaling)
+				  return ERROR;
+#endif
 				MrBayesPrint ("%s   WARNING: In LIKE_EPSILON - for division %d char %d has like = %1.30lf\n", spacer, division, c, like);
 				return ERROR;
 				}
@@ -13707,6 +14213,11 @@
 			/* check against LIKE_EPSILON (values close to zero are problematic) */
 			if (like < LIKE_EPSILON)
 				{
+#if defined(ALTSCALING)
+				  had_like_epsilon = 1;
+				  if (! did_scaling)
+				    return ERROR;
+#endif
 				MrBayesPrint ("%s   WARNING: In LIKE_EPSILON - for division %d char %d has like = %1.30lf\n", spacer, division, c, like);
 				return ERROR;
 				}
@@ -13736,7 +14247,8 @@
 
 	int				c, j, k, nStates;
 	MrBFlt			catLike, like, *bs, *omegaCatFreq;
-	CLFlt			*clP, *lnScaler, *nSitesOfPat;
+	CLFlt			*clP, *lnScaler;
+	CLFlt2                  *nSitesOfPat;
 	ModelInfo		*m;
 	
 	m = &modelSettings[division];
@@ -13775,6 +14287,11 @@
 		/* check against LIKE_EPSILON (values close to zero are problematic) */
 		if (like < LIKE_EPSILON)
 			{
+#if defined(ALTSCALING)
+			  had_like_epsilon = 1;
+			  if (! did_scaling)
+			    return ERROR;
+#endif
 			MrBayesPrint ("%s   WARNING: In LIKE_EPSILON - for division %d char %d has like = %1.30lf\n", spacer, division, c, like);
 			return ERROR;
 			}
@@ -13804,7 +14321,8 @@
 
 	int				c, k;
 	MrBFlt			*bs, freq, like, pUnobserved, pObserved;
-	CLFlt			*clP, *lnScaler, *nSitesOfPat;
+	CLFlt			*clP, *lnScaler;
+	CLFlt2                  *nSitesOfPat;
 	ModelInfo		*m;
 	
 	m = &modelSettings[division];
@@ -13845,6 +14363,11 @@
 	pObserved =  1.0 - pUnobserved;
 	if (pObserved < LIKE_EPSILON)
 		{
+#if defined(ALTSCALING)
+		  had_like_epsilon = 1;
+		  if (! did_scaling)
+		    return ERROR;
+#endif
 		MrBayesPrint ("%s   WARNING: p(Observed) < LIKE_EPSILON - for division %d p(Observed) = %1.30lf\n", spacer, division, pObserved);
 		return ERROR;
 		}
